From 0a63b4cf1053383c82392c1af17d0bace08a0b72 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Apr 26 2020 01:02:10 +0000
Subject: [PATCH 382/2232] Hide VectorElement methods from autocomplete


---

diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index 8b0b6a1..477495a 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -656,7 +656,7 @@ fn expand_vector(namespace: &Namespace, ty: &Type) -> TokenStream {
 
     quote! {
         impl ::cxx::private::VectorElement<#inner> for #inner {
-            fn get_unchecked(v: &::cxx::CxxVector<#inner>, pos: usize) -> &#inner {
+            fn __get_unchecked(v: &::cxx::CxxVector<#inner>, pos: usize) -> &#inner {
                 extern "C" {
                     #[link_name = #link_get_unchecked]
                     fn __get_unchecked(_: &::cxx::CxxVector<#inner>, _: usize) -> &#inner;
@@ -665,7 +665,7 @@ fn expand_vector(namespace: &Namespace, ty: &Type) -> TokenStream {
                     __get_unchecked(v, pos)
                 }
             }
-            fn vector_length(v: &::cxx::CxxVector<#inner>) -> usize {
+            fn __vector_length(v: &::cxx::CxxVector<#inner>) -> usize {
                 unsafe {
                     extern "C" {
                         #[link_name = #link_length]
@@ -674,7 +674,7 @@ fn expand_vector(namespace: &Namespace, ty: &Type) -> TokenStream {
                     __vector_length(v)
                 }
             }
-            fn push_back(v: &::cxx::CxxVector<#inner>, item: &#inner) {
+            fn __push_back(v: &::cxx::CxxVector<#inner>, item: &#inner) {
                 unsafe {
                     extern "C" {
                         #[link_name = #link_push_back]
@@ -699,7 +699,7 @@ pub fn expand_vector_builtin(ident: Ident) -> TokenStream {
 
     quote! {
         impl VectorElement<#inner> for #inner {
-            fn get_unchecked(v: &CxxVector<#inner>, pos: usize) -> &#inner {
+            fn __get_unchecked(v: &CxxVector<#inner>, pos: usize) -> &#inner {
                 extern "C" {
                     #[link_name = #link_get_unchecked]
                     fn __get_unchecked(_: &CxxVector<#inner>, _: usize) -> &#inner;
@@ -708,7 +708,7 @@ pub fn expand_vector_builtin(ident: Ident) -> TokenStream {
                     __get_unchecked(v, pos)
                 }
             }
-            fn vector_length(v: &CxxVector<#inner>) -> usize {
+            fn __vector_length(v: &CxxVector<#inner>) -> usize {
                 unsafe {
                     extern "C" {
                         #[link_name = #link_length]
@@ -717,7 +717,7 @@ pub fn expand_vector_builtin(ident: Ident) -> TokenStream {
                     __vector_length(v)
                 }
             }
-            fn push_back(v: &CxxVector<#inner>, item: &#inner) {
+            fn __push_back(v: &CxxVector<#inner>, item: &#inner) {
                 unsafe {
                     extern "C" {
                         #[link_name = #link_push_back]
diff --git a/src/cxx_vector.rs b/src/cxx_vector.rs
index f7185bb..7db8a45 100644
--- a/src/cxx_vector.rs
+++ b/src/cxx_vector.rs
@@ -16,11 +16,11 @@ pub struct CxxVector<T> {
 impl<T: VectorElement<T>> CxxVector<T> {
     /// Returns the length of the vector in bytes.
     pub fn size(&self) -> usize {
-        T::vector_length(self)
+        T::__vector_length(self)
     }
 
     pub fn get_unchecked(&self, pos: usize) -> &T {
-        T::get_unchecked(self, pos)
+        T::__get_unchecked(self, pos)
     }
 
     /// Returns true if `self` has a length of zero bytes.
@@ -37,7 +37,7 @@ impl<T: VectorElement<T>> CxxVector<T> {
     }
 
     pub fn push_back(&mut self, item: &T) {
-        T::push_back(self, item);
+        T::__push_back(self, item);
     }
 }
 
@@ -66,13 +66,13 @@ impl<'a, T: VectorElement<T>> Iterator for VectorIntoIterator<'a, T> {
 
 #[doc(hidden)]
 pub trait VectorElement<T> {
-    fn get_unchecked(v: &CxxVector<T>, pos: usize) -> &T
+    fn __get_unchecked(v: &CxxVector<T>, pos: usize) -> &T
     where
         Self: Sized;
-    fn vector_length(v: &CxxVector<T>) -> usize
+    fn __vector_length(v: &CxxVector<T>) -> usize
     where
         Self: Sized;
-    fn push_back(v: &CxxVector<T>, item: &T)
+    fn __push_back(v: &CxxVector<T>, item: &T)
     where
         Self: Sized;
 }

